// GraphLab Project: http://graphlab.sharif.edu
// Copyright (C) 2008 Mathematical Science Department of Sharif University of Technology
// Distributed under the terms of the GNU General Public License (GPL): http://www.gnu.org/licenses/
package graphlab.plugins.main.help;

import graphlab.graph.ui.GHTMLPageComponent;
import graphlab.platform.core.BlackBoard;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;

/**
 * @author Azin azadi
 *         Date: Aug 29, 2009
 */
public class QuestionAskUI {
    private JTextField questionTxt;
    private JPanel panel1;
    private JButton askButton;
    private JPanel panel;
    private JButton didnTYouGetButton;
    private JSplitPane split;
    //    private JPanel contentpanel;
    private GHTMLPageComponent topics;
    private GHTMLPageComponent content;
    private BlackBoard blackboard;

    public QuestionAskUI(BlackBoard blackBoard) {
        this.blackboard = blackBoard;
        questionTxt.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ask();
            }
        });
        askButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ask();
            }
        });
        questionTxt.addFocusListener(new FocusAdapter() {
            public void focusGained(FocusEvent e) {
                questionTxt.setText("");
                questionTxt.setForeground(Color.black);
            }

            public void focusLost(FocusEvent e) {
                if (questionTxt.getText().equals("")) {
                    setQuestionTextDefault();
                }
            }
        });
        setQuestionTextDefault();
    }

    private void setQuestionTextDefault() {
        questionTxt.setText("Type your question here...");
        questionTxt.setForeground(Color.gray);
    }

    private void ask() {

    }

    private void createUIComponents() {
        topics = new GHTMLPageComponent(blackboard);

        content = new GHTMLPageComponent(blackboard);
        split = new JSplitPane();
        split.setBottomComponent(content);
        split.setTopComponent(topics);
    }


    public JTextField getQuestionTextField() {
        return questionTxt;
    }

    public JPanel getRootPanel() {
        return panel1;
    }

    public GHTMLPageComponent getTopics() {
        return topics;
    }

    public GHTMLPageComponent getContent() {
        return content;
    }

    {
// GUI initializer generated by IntelliJ IDEA GUI Designer
// >>> IMPORTANT!! <<<
// DO NOT EDIT OR ADD ANY CODE HERE!
        $$$setupUI$$$();
    }

    /**
     * Method generated by IntelliJ IDEA GUI Designer
     * >>> IMPORTANT!! <<<
     * DO NOT edit this method OR call it in your code!
     *
     * @noinspection ALL
     */
    private void $$$setupUI$$$() {
        createUIComponents();
        panel1 = new JPanel();
        panel1.setLayout(new GridBagLayout());
        panel1.setBorder(BorderFactory.createTitledBorder(""));
        questionTxt = new JTextField();
        GridBagConstraints gbc;
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.weightx = 0.5;
        gbc.anchor = GridBagConstraints.WEST;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        panel1.add(questionTxt, gbc);
        askButton = new JButton();
        askButton.setText("Ask");
        gbc = new GridBagConstraints();
        gbc.gridx = 1;
        gbc.gridy = 0;
        gbc.anchor = GridBagConstraints.WEST;
        panel1.add(askButton, gbc);
        didnTYouGetButton = new JButton();
        didnTYouGetButton.setText("Didn't you get your answer? Submit it");
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 2;
        gbc.anchor = GridBagConstraints.WEST;
        panel1.add(didnTYouGetButton, gbc);
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 1;
        gbc.gridwidth = 2;
        gbc.weightx = 1.0;
        gbc.weighty = 1.0;
        gbc.fill = GridBagConstraints.BOTH;
        panel1.add(split, gbc);
    }

    /**
     * @noinspection ALL
     */
    public JComponent $$$getRootComponent$$$() {
        return panel1;
    }
}
