/*
 * CONFIDENTIAL AND CONTAINING PROPRIETARY TRADE SECRETS
 * Copyright (c) 2007 The MathWorks, Inc. All Rights Reserved.
 * The source code contained in this listing contains proprietary and
 * confidential trade secrets of The MathWorks, Inc.  The use, modification,
 * or development of derivative work based on the code or ideas obtained
 * from the code is prohibited without the express written permission of The
 * MathWorks, Inc. The disclosure of this code to any party not authorized
 * by The MathWorks, Inc. is strictly forbidden.
 * CONFIDENTIAL AND CONTAINING PROPRIETARY TRADE SECRETS
 */
window.mathworks = window.mathworks || {};

mathworks.UrlFactory = {
    getFunctionName: function(paramList) {
        var functionName;
        loop: for (var p in paramList) {
            var currentElement = paramList[p];
            if(currentElement.name==='function') {
                functionName = currentElement.value;
                break loop;
            }
        }
        return functionName;
    },
    buildUrl: function(parameterList) {
        var outputUrlString = '';

        if (parameterList) {
            //if a rootUrl is present append it and ensure that it ends in slash
            outputUrlString += mathworks.rootUrl;
            if (outputUrlString.length>0 && outputUrlString.charAt(outputUrlString.length-1) !== '/') {
                 outputUrlString += '/';
            }
            
            //append the serviceroot (this can be overloaded depending on how it should be called.  
            outputUrlString += this.getServiceRoot(parameterList);
                       
            //if there are parameters add them
            if(parameterList){
                for (var p in parameterList) {
                    //What if it ends in a '/'? 
                    //Should i remove the / and proceed with this code?
                    if( outputUrlString && 
                        outputUrlString.length>0 && 
                        outputUrlString.charAt(outputUrlString.length-1) !== '?' &&
                        outputUrlString.charAt(outputUrlString.length-1) !== '&') {
                        outputUrlString += '&';
                    }


                    var currentParam = parameterList[p];
                    //We leave it up to the ServiceRoot to tag the function parameter to the string
                    if(currentParam.name!=="function") {
                        //Since we know these parameters are garenteed to be used in a
                        // URL string and not for anything else we should encode at this point.
                        outputUrlString += escape(currentParam.name) + "=" + escape(currentParam.value);
                    }
                }
            }
        }
        return outputUrlString;
    },  
    addParam: function(outputParamList,argName,argValue) {
        outputParamList[outputParamList.length] = {name: argName, value: argValue};
    },
    addParams: function(outputParamList,inputParamList) {
        if(inputParamList){
            for (var p in inputParamList) {
                var currentParam = inputParamList[p];
                this.addParam(outputParamList, currentParam.name, currentParam.value);
            }
        }    
    },  
    addCheckedParam: function(outputParamList,paramList,argName,argParamListName) {
        if(argParamListName in paramList) {
            this.addParam(outputParamList,argName,paramList[argParamListName]);
        }
    },
    addCheckedIntParam: function(outputParamList,paramList,argName,argParamListName) {
        if(argParamListName in paramList) {
            this.addParam(outputParamList,argName,parseInt(paramList[argParamListName], 10));
        }
    }
};