// GraphLab Project: http://graphlab.sharif.edu
// Copyright (C) 2008 Mathematical Science Department of Sharif University of Technology
// Distributed under the terms of the GNU General Public License (GPL): http://www.gnu.org/licenses/

package graphlab.graph.graph;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;

/**
 * @author azin azadi
 * @email
 */
public class SubGraph {
    public GraphModel graph;

    public SubGraph(GraphModel graph) {
        this.graph = graph;
    }

    public HashSet<VertexModel> vertices = new HashSet<VertexModel>();
    public HashSet<EdgeModel> edges = new HashSet<EdgeModel>();
    public String label = "";


    /**
     * using this constructor the selected graph will be considered as the default graph in the blackboard
     */
    public SubGraph() {
        graph = null;
    }

    public ArrayList<VertexModel> getNeighbors(VertexModel v) {
        ArrayList<VertexModel> ret = new ArrayList<VertexModel>();
        for (VertexModel nv : graph.getNeighbors(v)) {
            if (vertices.contains(nv))
                ret.add(nv);
        }
        return ret;
    }

    @Override
    public String toString() {
        String txt = "";
        if (label != null && !label.equals("")) {
            txt += label + ": \n";
        }
        if (vertices != null && vertices.size() > 0) {
            txt = txt + "V: {";
            for (VertexModel v : vertices) {
                txt = txt + v.getLabel() + ", ";
            }
            txt = txt.substring(0, txt.length() - 2) + "}";
        }
        if (edges != null && edges.size() > 0) {
            txt += "\nE: {";
            for (EdgeModel e : edges) {
                txt = txt + e.getLabel() + ", ";
            }
            txt = txt.substring(0, txt.length() - 2) + "}";
        }
        return txt;
    }

}
