// GraphLab Project: http://graphlab.sharif.edu
// Copyright (C) 2008 Mathematical Science Department of Sharif University of Technology
// Distributed under the terms of the GNU Lesser General Public License (LGPL): http://www.gnu.org/licenses/

package graphlab.platform.extension;

/**
 * The father of all extensions
 * @see graphlab.platform.extension.Extension
 * @see graphlab.ui.extension.UIActionExtension
 *
 * If an extension only implements this interface it will be loaded with it's constructor
 * getting the blackboard or with it's default constructor.
 *
 * This extension is usefull for doing initialization on application loading, or background
 * functionalities without any UI components.
 *
 * @author Azin Azadi
 */
public interface BasicExtension {
}
