// GraphLab Project: http://graphlab.sharif.edu
// Copyright (C) 2008 Mathematical Science Department of Sharif University of Technology
// Distributed under the terms of the GNU General Public License (GPL): http://www.gnu.org/licenses/

package graphlab.platform.lang;

/**
 * A pair of two objects
 * @author Omid
 */
public class Pair<First, Second> {
    public First first;
    public Second second;

    public Pair(First f, Second s) {
        first = f;
        second = s;
    }

    public boolean equals(Object obj) {
        if (obj == null)
            return false;
        if (!(obj instanceof Pair))
            return false;
        Pair t = (Pair) obj;
        if (first == null || second == null)
            return false;
        return !(!first.equals(t.first) || !second.equals(t.second));
    }

    public int hashCode() {
        return first.hashCode() + 100000 * second.hashCode();
    }

    public String toString() {
        return first.toString() + ", " + second.toString();
    }

}
