// GraphLab Project: http://graphlab.sharif.edu
// Copyright (C) 2008 Mathematical Science Department of Sharif University of Technology
// Distributed under the terms of the GNU General Public License (GPL): http://www.gnu.org/licenses/
package graphlab.plugins.reports.extension;

import graphlab.platform.core.BlackBoard;
import graphlab.plugins.main.GraphData;
import graphlab.ui.AbstractExtensionAction;
import graphlab.ui.UIUtils;
import graphlab.ui.components.gpropertyeditor.GCellRenderer;
import graphlab.ui.components.utils.GFrameLocationProvider;

import javax.swing.*;
import java.awt.*;

/**
 * @author azin azadi

 */
public class GraphReportExtensionAction extends AbstractExtensionAction {
    protected GraphReportExtension mr;

    public GraphReportExtensionAction(BlackBoard bb, GraphReportExtension gg) {
        super(bb, gg);
        this.mr = gg;
    }

    public String getParentMenuName() {
        return "Graph.Reports";
    }

    public Object performExtensionInCommandLine() {
        return mr.calculate(new GraphData(blackboard));
    }


    public void performExtension() {
//        if (testAndSetParameters(gr)) {
        new Thread() {

            public void run() {
                JDialog jd = new JDialog(UIUtils.getGFrame(blackboard));
                jd.setVisible(true);
                jd.setTitle(mr.getName());
                jd.setLayout(new BorderLayout(3, 3));
                jd.add(new JLabel(mr.getDescription()), BorderLayout.NORTH);
                Object result = mr.calculate(new GraphData(blackboard));
                Component rendererComponent = GCellRenderer.getRendererFor(result);
                rendererComponent.setEnabled(true);
                jd.add(rendererComponent, BorderLayout.CENTER);
                jd.setLocation(GFrameLocationProvider.getPopUpLocation());
                jd.pack();

            }
        }.start();
    }

}
